﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Opticon;

namespace OseCommApp.CSharp
{
	public partial class VariablesForm : Form
	{
		private string _formText = "";
		private string _variableKey;
		private string _variableValue;
		private bool _includeTerminalID;
		private OseComm.VariableDataFormat _variableDataFormat;
		private bool _isSetVariable = true;

		public VariablesForm()
		{
			InitializeComponent();
		}
		
		private void Variables_Load(object sender, EventArgs e)
		{
			Text = _formText;
			comboBoxDataFormat.Items.AddRange(Enum.GetNames(typeof(OseComm.VariableDataFormat)));
			comboBoxDataFormat.SelectedIndex = 0;

			if (_isSetVariable)
			{
				checkBoxTerminalID.Enabled = false;
				labelDataFormat.Enabled = false;
				comboBoxDataFormat.Enabled = false;
			}
			else
			{
				labelVariableValue.Enabled = false;
				textBoxVarValue.Enabled = false;
			}
		}

		#region Properties
		public string VariableKey
		{
			get
			{
				return _variableKey; 
			}
		}

		public string VariableValue
		{
			get
			{
				return _variableValue;
			}
		}

		public string FormText
		{
			set
			{
				_formText = value;
			}
		}

		public bool IncludeTerminalID
		{
			get
			{
				return _includeTerminalID;
			}
		}

		public OseComm.VariableDataFormat VariableDataFormat
		{
			get
			{
				return _variableDataFormat;
			}
		}

		public bool IsSetVariable
		{
			set
			{
				_isSetVariable = value;
			}
		}
		#endregion
		
		private void buttonOK_Click(object sender, EventArgs e)
		{
			_variableKey = textBoxVarKey.Text;
			_variableValue = textBoxVarValue.Text;
			_includeTerminalID = checkBoxTerminalID.Checked;
			_variableDataFormat = (OseComm.VariableDataFormat)Enum.Parse(typeof(OseComm.VariableDataFormat), (string)comboBoxDataFormat.SelectedItem);
		}

	}
}
